# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Nemis (nemis.post@gmail.com)
# Ubuntu One integration based on this tutorial http://developer.ubuntu.com/resources/tutorials/all/practical-ubuntu-one-files-integration/
# 
# GNU LESSER GENERAL PUBLIC LICENSE
# 
# Version 3, 29 June 2007
# 
# see http://www.opensource.org/licenses/LGPL-3.0
### END LICENSE

import gettext
from gettext import gettext as _
gettext.textdomain('wind')

from gi.repository import Gtk # pylint: disable=E0611
import logging
logger = logging.getLogger('wind')

from wind_lib import Window
from wind.AboutWindDialog import AboutWindDialog
from wind.PreferencesWindDialog import PreferencesWindDialog
import os
from quickly import prompts
from quickly.widgets.dictionary_grid import DictionaryGrid
import time

# See wind_lib.Window.py for more details about how this class works
class WindWindow(Window):
    __gtype_name__ = "WindWindow"
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the main window"""
        super(WindWindow, self).finish_initializing(builder)

        self.AboutDialog = AboutWindDialog
        self.PreferencesDialog = PreferencesWindDialog
        self.supported_formats = [".py"]
        # Code for other initialization actions should be added here.
        try:
			os.mkdir("wind")
        except:
			print _("!mkdir error.")
            print _(" If this is the first time you use Wind,")
            print _(" this might give trouble later.")
            try:
                os.remove("wind/uploading")
            except:
                print _("!remove error, this might give trouble later (file:uploading)")
            try:
                os.remove("wind/windinfo")
            except:
                print _("!remove error, this might give trouble later (file:windinfo)")
            
        
        path = "wind"

    def on_sendbutton_clicked(self, widget, data=None):
        login()
        create_volume("wind")
        
        path = "wind"
        
        for root, dirs, files in os.walk(path):
			#iterate through each file
			print root
			print dirs
			print files
            for f in files:
                #check if the file is a supported formats
				#create a URI in a format gstreamer likes
				file_uri = "file://" + os.path.join(root,f)
				filepath = os.path.join(root,f)
				print filepath
				print file_uri
		        fo = open("wind/uploading", "w")
		        fo.write("Done")
		        fo.close()
		        putinfo("wind/uploading", "wind/uploading")
				put(filepath, "wind/" + f)
                delete("wind/uploading")
				print "startwait"
				while (query("wind/" + f) == "true"):
					print _("waiting 10s")
					time.sleep(10)
		fo = open("wind/windinfo", "w")
		fo.write("Done")
		fo.close()
		put("wind/windinfo", "wind/windinfo")
		print _("Finished sending files")
    
    def on_getbutton_clicked(self, widget, data=None):
        while (fileexists("wind", "windinfo") == "false"):
			print "inWhile"
            if (query("wind/uploading") == "false"):
	            steal_folder("wind")
            else:
                print _("upload in progress,")
	        if (fileexists("wind", "windinfo") == "false"):
	            print "waiting 20s"
		        time.sleep(20)
	    print _("Finished getting files")

    def on_switchbutton_clicked(self, widget, data=None):
        logout()
        login()
        

def fileexists(path, name):
	print "fileexists"
	for root, dirs, files in os.walk(path):
		for f in files:
			print f
			if f == name:
				return "true"
	return "false"
	
#u1Syncer

#Login
_login_success = False
def login():
  from gobject import MainLoop
  from dbus.mainloop.glib import DBusGMainLoop
  from ubuntuone.platform.credentials import CredentialsManagementTool
  print _("#Waiting for login")
  global _login_success
  _login_success = False
 
  DBusGMainLoop(set_as_default=True)
  loop = MainLoop()
 
  def quit(result):
    global _login_success
    loop.quit()
    if result:
            _login_success = True
 
  cd = CredentialsManagementTool()
  d = cd.login()
  d.addCallbacks(quit)
  loop.run()
  if not _login_success:
    sys.exit(1)
  print _("#Logged in")

#Logout
def logout():
  from gobject import MainLoop
  from dbus.mainloop.glib import DBusGMainLoop
  from ubuntuone.platform.credentials import CredentialsManagementTool
 
  DBusGMainLoop(set_as_default=True)
  loop = MainLoop()
 
  def quit(result):
    loop.quit()
 
  cd = CredentialsManagementTool()
  d = cd.clear_credentials()
  d.addCallbacks(quit)
  loop.run()
  print _("#Logged out")

#Create volume
def create_volume(path):
  print _("#Creating volume")
  import ubuntuone.couch.auth as auth
  import urllib
  base = "https://one.ubuntu.com/api/file_storage/v1/volumes/~/"
  auth.request(base + urllib.quote(path), http_method="PUT")
  print _("#Created volume")

#Upload
def put(local, remote):
  import json
  import ubuntuone.couch.auth as auth
  import mimetypes
  import urllib
  try:
      print "#Create remote path (which contains volume path)"
      base = "https://one.ubuntu.com/api/file_storage/v1/~/"
      answer = auth.request(base + urllib.quote(remote),
	    					http_method="PUT",
    						request_body='{"kind":"file"}')
      node = json.loads(answer[1])
      print "#Read info about local file"
      data = bytearray(open(local, 'rb').read())
      size = len(data)
      content_type = mimetypes.guess_type(local)[0]
      content_type = content_type or 'application/octet-stream'
      headers = {"Content-Length": str(size),
    			 "Content-Type": content_type}
      print _("#Upload content of local file")
      base = "https://files.one.ubuntu.com"
      url = base + urllib.quote(node.get('content_path'), safe="/~")
      auth.request(url, http_method="PUT",
    			   headers=headers, request_body=data)
      # TRANSLATOR: After ':' comes a filename
      print _("#Uploaded file as: ") + remote
  except:
      print _("Error while uploading ") + local + _(" to ") + remote
	   
#UploadInfo
def putinfo(local, remote):
  import json
  import ubuntuone.couch.auth as auth
  import mimetypes
  import urllib
  try:
      print _("#Uploading info")
      base = "https://one.ubuntu.com/api/file_storage/v1/~/"
      answer = auth.request(base + urllib.quote(remote),
	    					http_method="PUT",
    						request_body='{"kind":"file"}')
      node = json.loads(answer[1])

      data = bytearray(open(local, 'rb').read())
      size = len(data)
      content_type = mimetypes.guess_type(local)[0]
      content_type = content_type or 'application/octet-stream'
      headers = {"Content-Length": str(size),
    			 "Content-Type": content_type}
      print _("#Uploaded fileinfo as: ") + remote
  except:
      print _("Error while uploading (info) ") + local + _(" to ") + remote

#Download
def get(remote, local):
  import json
  import ubuntuone.couch.auth as auth
  import urllib
 
  print _("#Request metadata")
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  answer = auth.request(base + urllib.quote(remote))
  node = json.loads(answer[1])
 
  print _("#Request content")
  base = "https://files.one.ubuntu.com"
  url = base + urllib.quote(node.get('content_path'), safe="/~")
  answer = auth.request(url)
  f = open(local, 'wb')
  f.write(answer[1])
  print _("#Downloaded ") + local

#Download folder
def get_folder(path):
  import json
  import ubuntuone.couch.auth as auth
  import urllib
 
  print "#Request children metadata"
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  url = base + urllib.quote(path) + "?include_children=true"
  answer = auth.request(url)
 
  print "#Create file list out of json data"
  filelist = []
  node = json.loads(answer[1])
  if node.get('has_children') == True:
	children = node.get('children')
	filestodownload = str(children.count)
	print _("#Files to download: ")
    for child in node.get('children'):
      child_path = urllib.unquote(child.get('path')).lstrip('/')
      filelist += [child_path]
    print filelist
    print ""
	i = 0
    for child in children:
	  i = i + 1
      child_path = urllib.unquote(child.get('path')).lstrip('/')
      filelist += [child_path]
      remotefile = path + "/" + child_path
      print _("#Now downloading ") + remotefile + _(" (file ") + str(i) + ")"
      get(remotefile, child_path)
  else:
	  print _("No files to download")
  print "Done"
  
#'Steal' folder
def steal_folder(path):
  import json
  import ubuntuone.couch.auth as auth
  import urllib
 
  print "#Request children metadata"
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  url = base + urllib.quote(path) + "?include_children=true"
  answer = auth.request(url)
 
  print "#Create file list out of json data"
  filelist = []
  node = json.loads(answer[1])
  if node.get('has_children') == True:
	children = node.get('children')
	filestodownload = str(children.count)
	print _("#Files to download: ")
    for child in node.get('children'):
      child_path = urllib.unquote(child.get('path')).lstrip('/')
      filelist += [child_path]
    print filelist
    print ""
	i = 0
    for child in children:
	  i = i + 1
      child_path = urllib.unquote(child.get('path')).lstrip('/')
      filelist += [child_path]
      remotefile = path + "/" + child_path
      print _("#Now downloading ") + remotefile + _(" (file ") + str(i) + ")"
      get(remotefile, "wind/" + child_path)
      delete(remotefile)
  else:
	  print _("No files to download")

#List
def get_children(path):
  import json
  import ubuntuone.couch.auth as auth
  import urllib
 
  print "#Request children metadata"
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  url = base + urllib.quote(path) + "?include_children=true"
  answer = auth.request(url)
 
  print "#Create file list out of json data"
  filelist = []
  node = json.loads(answer[1])
  if node.get('has_children') == True:
    for child in node.get('children'):
      child_path = urllib.unquote(child.get('path')).lstrip('/')
      filelist += [child_path]
  print ""
  print _("Files:")
  print filelist

#Query
def query(path):
  import json
  import ubuntuone.couch.auth as auth
  import urllib
 
  print "#Request metadata"
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  url = base + urllib.quote(path)
  answer = auth.request(url)
  node = json.loads(answer[1])
 
  print "#Print interesting info"
  print 'Size:', node.get('size')
  if node.get('size') > 0:
	  return "true"
  else:
	  return "false"

#Delete
def delete(path):
  print _("#Deleting ") + path
  import ubuntuone.couch.auth as auth
  import urllib
  base = "https://one.ubuntu.com/api/file_storage/v1/~/"
  auth.request(base + urllib.quote(path), http_method="DELETE")
  print _("#Gone")
