# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Nemis (nemis.post@gmail.com)
# Ubuntu One integration based on this tutorial http://developer.ubuntu.com/resources/tutorials/all/practical-ubuntu-one-files-integration/
# 
# GNU LESSER GENERAL PUBLIC LICENSE
# 
# Version 3, 29 June 2007
# 
# see http://www.opensource.org/licenses/LGPL-3.0
### END LICENSE

# THIS IS Wind CONFIGURATION FILE
# YOU CAN PUT THERE SOME GLOBAL VALUE
# Do not touch unless you know what you're doing.
# you're warned :)

__all__ = [
    'project_path_not_found',
    'get_data_file',
    'get_data_path',
    ]

# Where your project will look for your data (for instance, images and ui
# files). By default, this is ../data, relative your trunk layout
__wind_data_directory__ = '../data/'
__license__ = 'other'
__version__ = 'VERSION'

import os

import gettext
from gettext import gettext as _
gettext.textdomain('wind')

class project_path_not_found(Exception):
    """Raised when we can't find the project directory."""


def get_data_file(*path_segments):
    """Get the full path to a data file.

    Returns the path to a file underneath the data directory (as defined by
    `get_data_path`). Equivalent to os.path.join(get_data_path(),
    *path_segments).
    """
    return os.path.join(get_data_path(), *path_segments)


def get_data_path():
    """Retrieve wind data path

    This path is by default <wind_lib_path>/../data/ in trunk
    and /usr/share/wind in an installed version but this path
    is specified at installation time.
    """

    # Get pathname absolute or relative.
    path = os.path.join(
        os.path.dirname(__file__), __wind_data_directory__)

    abs_data_path = os.path.abspath(path)
    if not os.path.exists(abs_data_path):
        raise project_path_not_found

    return abs_data_path


def get_version():
    return __version__
